function parent(TREE, uid) {
	if ((uid, C99F_PARENT) in TREE)
		return TREE[uid, C99F_PARENT]
	return ""
}

function nxt(TREE, uid) {
	if ((uid, C99F_NEXT) in TREE)
		return TREE[uid, C99F_NEXT]
	return ""
}

function prv(TREE, uid) {
	if ((uid, C99F_PREV) in TREE)
		return TREE[uid, C99F_PREV]
	return ""
}

function child(TREE, uid,   ch_idx) {
	if ((uid, C99F_CHILD, int(ch_idx)) in TREE)
		return TREE[uid, C99F_CHILD, int(ch_idx)]
	return ""
}

function num_children(TREE, uid)
{
	if ((uid, C99F_CHILDREN) in TREE)
		return TREE[uid, C99F_CHILDREN]
	return ""
}

function safe_name(TREE, uid)
{
	if (!((uid, C99F_NAME) in TREE) || (TREE[uid, C99F_NAME] == ""))
		return "<anon-" uid ">"
	return TREE[uid, C99F_NAME]
}

function select_sibling_type(TREE, uid, type, count) {
	count = int(count)
	while(uid != "") {
		if (TREE[uid, C99F_TYPE] == type) {
			if (count == 0)
				return uid
			count--
		}
		uid = TREE[uid, C99F_NEXT]
	}
	return ""
}

function select_sibling_name(TREE, uid, name,    count, type) {
	count = int(count)
	while(uid != "") {
		if ((type != "") && (TREE[uid, C99F_TYPE] != type))
			continue
		if (TREE[uid, C99F_NAME] == name) {
			if (count == 0)
				return uid
			count--
		}
		uid = TREE[uid, C99F_NEXT]
	}
	return ""
}

function select_child_type(TREE, uid, type, count) {
	return select_sibling_type(TREE[uid, C99F_CHILD, 0], type, count);
}

function typedef_name(TREE, uid,   none)
{
	if (TREE[parent(TREE, parent(TREE, uid)), C99F_TYPE] == C99T_TYPEDEF)
		return TREE[select_sibling_type(TREE, parent(TREE, uid), C99T_ID, 0), C99F_NAME]
	return none
}

# create a list of parent UIDs in UIDS[0..(l-1)]. Order is from top to bottom.
# Returns l, the length of the list, ans also sets UIDS["len"] = l
function scope(TREE, UIDS, start_uid   ,uid,n,v,l)
{
	v = 0
	for(uid = parent(TREE, start_uid); uid != ""; uid = parent(TREE, uid)) {
		if ((TREE[uid, C99F_TYPE] == C99T_ENUM) || (TREE[uid, C99F_TYPE] == C99T_UNION) || (TREE[uid, C99F_TYPE] == C99T_STRUCT) || (TREE[uid, C99F_TYPE] == C99T_FUNCDEF)) {
			UIDS[v] = uid;
			v++
		}
	}

# swap the order of the list
	for(n = 0; n < v/2; n++) {
		l = v - n - 1
		uid = UIDS[n]
		UIDS[n] = UIDS[l]
		UIDS[l] = uid
	}

	UIDS["len"] = v
	return v
}

function is_scope(type)
{
# (C99T_BLOCK) ||
	return (type==C99T_FUNCDEF) || (type == C99T_ENUM) || (type == C99T_STRUCT) || (type == C99T_UNION)
}

function scope_str(TREE, uid    ,path)
{
	for(;;) {
		uid = TREE[uid, C99F_PARENT]
		if (uid == "")
			return path
		if (is_scope(TREE[uid, C99F_TYPE]))
			if (path == "")
				path = TREE[uid, C99F_NAME]
			else
				path = TREE[uid, C99F_NAME] "." path
	}
}

