/*
    c99tree - postprocess the tree
    Copyright (C) 2015  Tibor Palinkas

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#include <stdlib.h>
#include "tree.h"

static void postproc(node_t *root)
{
	node_t *n;
	for(n = root->children; n != NULL; n = n->next) {
		n->parent = root;
		if (n->children != NULL)
			postproc(n);
	}
}

void tree_postproc(node_t *root)
{
	for(; root != NULL; root = root->next)
		postproc(root);
}
